<?php
/*
Plugin Name: POSTALLORBUST (Related Posts Widget)
Plugin URI: http://wordpress.ieonly.com/category/my-plugins/related-posts-widget/
Author: Eli Scheetz
Author URI: http://wordpress.ieonly.com/
Description: Posts On Sidebar That Are Listed and Linked Organically Related By Using Same Tags. Just drop this widget on your sidebar and you will see a linked list of other Posts that use any of the same Tags as the post you are on (if your on a page that shows only a sigle Post).
Version: 1.1.10.21
*/
/**
 * POSTALLORBUST Main Plugin File
 * @package POSTALLORBUST
*/
/*  Copyright 2011 Eli Scheetz (email: wordpress@ieonly.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
function POSTALLORBUST_install() {
	global $wp_version;
	if (version_compare($wp_version, "2.6", "<")) {
		deactivate_plugins(basename(__FILE__));
		wp_die("This Plugin requires WordPress version 2.6 or higher");
	}
}
class POSTALLORBUST_Widget_Class extends WP_Widget {
	function POSTALLORBUST_Widget_Class() {
		$this->WP_Widget('POSTALLORBUST-Widget', __('Related Posts'), array('classname' => 'widget_POSTALLORBUST', 'description' => __('Linked list of related Posts by Tags')));
		$this->alt_option_name = 'widget_POSTALLORBUST';
	}
	function widget($args, $instance) {
		global $post;
		$global_post = $post;
		if (have_posts()) {
			the_post();
			$pID = $post->ID;
			$tags_query = "";
			$comma = "tag=";
			if ($all_tags = get_the_tags()) {
				foreach ($all_tags as $tag) {
					$tags_query .= $comma.$tag->name;
					$comma = ",";
				}
			}
			if ((!have_posts()) && strlen($tags_query) > 0) {
				query_posts($tags_query);
				extract($args);
				if (!$instance['title'])
					$instance['title'] = "Related Posts";
				if (!$instance['number'])
					$instance['number'] = 5;
				echo $before_widget.$before_title.$instance["title"].$after_title."<ul>\n";
				for ($p = 0; $p <= $instance['number'] && have_posts(); $p++) {
					the_post();
					if ($pID != $post->ID) {
						echo '<li class="POSTALLORBUST-Related-Post"><a title="';
						the_title_attribute();
						echo '" href="';
						the_permalink();
						echo '" rel="bookmark">';
						the_title();
						echo "</a></li>\n";
					}
				} 
				echo "</ul>\n".$after_widget;
			}
		}
		$post = $global_post;
	}
	function flush_widget_cache() {
		wp_cache_delete('widget_POSTALLORBUST', 'widget');
	}
	function update($new, $old) {
		$instance = $old;
		$instance['title'] = strip_tags($new['title']);
		$instance['number'] = (int) $new['number'];
		return $instance;
	}
	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$number = isset($instance['number']) ? absint($instance['number']) : 5;
		echo '<p><label for="'.$this->get_field_id('title').'">Alternative Title:</label>
		<input type="text" name="'.$this->get_field_name('title').'" id="'.$this->get_field_id('title').'" value="'.$title.'" /></p>
		<p><label for="'.$this->get_field_id('number').'">Number of Posts to List:</label>
		<input type="text" size="2" name="'.$this->get_field_name('number').'" id="'.$this->get_field_id('number').'" value="'.$number.'" /></p>';
	}
}
register_activation_hook(__FILE__,'POSTALLORBUST_install');
add_action('widgets_init', create_function('', 'return register_widget("POSTALLORBUST_Widget_Class");'));
?>
